
Redmine - Defect #23645

Gantt bars for single-day tasks may be rendered wrongly in PDF

2016-08-23 18:50 - Daniel Ritz
Category: Gantt Estimated time: 0.00 hour

Target version: 4.0.7   

Resolution:  Affected version:  

Description

When a task starts and ends on the same day, it can happen that the bar in the PDF is rendered wrong, i.e. it's rendered from the

start day to the right end of the page.

The problem is in lib/redmine/helpers/gantt.rb. When #pdf_task is called, coords[:bar_end] - coords[:bar_start] happens to be 0. The

cause for this is the zoom factor applied in #coordindates and the subsequent #floor. By adding some Rails.logger statements I got

this:

coords[start]: 92/1, zoom: 36/73

coords[start]: 45

coords[bar_start]: 92/1, zoom: 36/73

coords[bar_start]: 45

coords[end]: 92/1, zoom: 36/73

coords[end]: 45

coords[bar_end]: 93/1, zoom: 36/73

coords[bar_end]: 45

Each value shown before/after applying zoom.  While before zoom, the values where 92/93, the became 45/45 afterwards.   

The attached patch fixes the PDF rendering problem by making sure, the with used in the RDMCell() call is at least 0.

Related issues:

Has duplicate Redmine - Defect #32916: Bar length is wrong when exporting gan... Closed

Associated revisions

Revision 19592 - 2020-03-20 05:48 - Go MAEDA

Gantt bars for single-day tasks may be rendered wrongly in PDF (#23645).

Patch by Daniel Ritz.

Revision 19593 - 2020-03-20 05:52 - Go MAEDA

Merged r19592 from trunk to 4.1-stable (#23645).

Revision 19594 - 2020-03-20 05:56 - Go MAEDA

Merged r19592 from trunk to 4.0-stable (#23645).

History

#1 - 2017-01-02 16:59 - Sutamin Lynfiled

- File gannt_1daytask.JPG added

LGTM. I hope for early adoption.

#2 - 2017-01-04 01:52 - Go MAEDA

I have not been able to reproduce the problem yet.

Could you please describe the detailed steps to reproduce the problem and upload screenshots (before fix and after fix) ?

#3 - 2017-01-04 11:47 - Daniel Ritz

- File pdf-vs-png.png added

2025-05-17 1/2



Sorry, I have no easy reproducer. I used a dump of our productive DB while working on the fix...

Attached is a screenshot with comparing the Gantt rendered correctly as PNG and incorrectly as PDF. After the fix, the PDF looks correct too (no

screenshot taken).

Tasks 3-7 shown on the screenshot are single-day tasks and should all render the same.

 pdf-vs-png.png 

#4 - 2020-03-19 08:28 - Yuichi HARADA

- File set-huge-months.png added

- File actual-pdf.png added

Daniel Ritz wrote:

When a task starts and ends on the same day, it can happen that the bar in the PDF is rendered wrong, i.e. it's rendered from the start day to the

right end of the page.

 I have confirmed.

If you set a huge value to the Gantt display months, all Gantt bars for issues with the extremely short the start date and due date will appear in the

PDF this way.

 set-huge-months.png 

 actual-pdf.png 

The attached patch fixes the PDF rendering problem by making sure, the with used in the RDMCell() call is at least 0.

 I think gantt-single-day-task-pdf-rendering.patch should be incorporated. This problem will be solved.

#5 - 2020-03-19 15:28 - Go MAEDA

- Target version set to 4.0.7

Setting the target version to 4.0.7.

#6 - 2020-03-20 05:56 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch. Thank you for your contribution.

#7 - 2020-03-20 05:57 - Go MAEDA

- Tracker changed from Patch to Defect

- Subject changed from Fix Gantt PDF rendering for single-day tasks to Gantt bars for single-day tasks may be rendered wrongly in PDF

#8 - 2020-06-15 06:38 - Mischa The Evil

- Has duplicate Defect #32916: Bar length is wrong when exporting gantt chart to PDF added

Files

gantt-single-day-task-pdf-rendering.patch 1.71 KB 2016-08-23 Daniel Ritz

gannt_1daytask.JPG 55.3 KB 2017-01-02 Sutamin Lynfiled

pdf-vs-png.png 47.3 KB 2017-01-04 Daniel Ritz

set-huge-months.png 235 KB 2020-03-19 Yuichi HARADA

actual-pdf.png 332 KB 2020-03-19 Yuichi HARADA
